# EKF< sq_T > Class Template Reference

Extended Kalman Filter. More...

`#include <libKF.h>`

Inheritance diagram for EKF< sq_T >:

[legend]
Collaboration diagram for EKF< sq_T >:

[legend]

List of all members.

## Public Member Functions
| EKF (RV rvx, RV rvy, RV rvu)
| Default constructor.
void | set_parameters (diffbifn *pfxu, diffbifn *phxu, const sq_T Q0, const sq_T R0)
| Set nonlinear functions for mean values and covariance matrices.
void | bayes (const vec &dt)
| Here dt = [yt;ut] of appropriate dimensions.
void | set_parameters (const mat &A0, const mat &B0, const mat &C0, const mat &D0, const fsqmat &R0, const fsqmat &Q0)
| Set parameters with check of relevance.
void | set_est (const vec &mu0, const fsqmat &P0)
| Set estimate values, used e.g. in initialization.
const epdf & | _epdf () const
| access function
mat & | __K ()
| access function
vec | _dP ()
| access function
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
const RV & | _rv () const
| access function
double | _ll () const
| access function
void | set_evalll (bool evl0)
| access function
virtual BM * | _copy_ (bool changerv=false)
## Protected Attributes
RV | rvy
| Indetifier of output rv.
RV | rvu
| Indetifier of exogeneous rv.
int | dimx
| cache of rv.count()
int | dimy
| cache of rvy.count()
int | dimu
| cache of rvu.count()
mat | A
| Matrix A.
mat | B
| Matrix B.
mat | C
| Matrix C.
mat | D
| Matrix D.
fsqmat | Q
| Matrix Q in square-root form.
fsqmat | R
| Matrix R in square-root form.
enorm< fsqmat > | est
| posterior density on $x_t$
enorm< fsqmat > | fy
| preditive density on $y_t$
mat | _K
| placeholder for Kalman gain
vec & | _yp
| cache of fy.mu
fsqmat & | _Ry
| cache of fy.R
vec & | _mu
| cache of est.mu
fsqmat & | _P
| cache of est.R
RV | rv
| Random variable of the posterior.
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.

## Detailed Description

### template<class sq_T>
class EKF< sq_T >

Extended Kalman Filter.

An approximation of the exact Bayesian filter with Gaussian noices and non-linear evolutions of their mean.

## Member Function Documentation

virtual double BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in ARX, MixEF, and multiBM.

virtual BM* BM::_copy_ | ( | bool | changerv = `false` | ) | `[inline, virtual, inherited]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype: BM* _copy_(){BM Tmp*=new Tmp(this*); return Tmp; }

Reimplemented in ARX.

Referenced by MixEF::MixEF().

The documentation for this class was generated from the following file:

- work/git/mixpp/bdm/estim/libKF.h